<?php

	$pluginData[bitpay][type] = 'payment';
	$pluginData[bitpay][name] = 'پرداخت آنلاین با bitpay';
	$pluginData[bitpay][uniq] = 'bitpay';
	$pluginData[bitpay][description] = '';
	$pluginData[bitpay][author][name] = 'تیم توسعه bitpay.ir';
	$pluginData[bitpay][author][url] = 'http://bitpay.ir';
	$pluginData[bitpay][author][email] = 'info@bitpay.ir';

	$pluginData[bitpay][field][config][1][title] = 'لطفا API خود را در فیلد زیر وارد نمایید ';
	$pluginData[bitpay][field][config][1][name] = 'pin';


    function send($url,$api,$amount,$redirect,$email,$description){
        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,$url);
        curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&amount=$amount&redirect=$redirect&email=$email&description=$description");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
        $res = curl_exec($ch);
        curl_close($ch);
        return $res;
    }
    function get($url,$api,$trans_id,$id_get){
        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,$url);
        curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&id_get=$id_get&trans_id=$trans_id");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
        $res = curl_exec($ch);
        curl_close($ch);
        return $res;
    }
	function gateway__bitpay($data)
	{
		global $config,$smarty,$db;
		$api = $data[pin];
        $amount = $data[amount];
        $redirect = $data[callback];
		
		$sql = 'SELECT * FROM `payment` WHERE `payment_rand` = "'.$data[invoice_id].'" LIMIT 1;';
		$payment = $db->fetch($sql);
		
		$email		= $payment[payment_email];
		$description  = 'شماره سفارش : '.$data[invoice_id].', شماره موبایل : '.$payment[payment_mobile];
		
		$order_id		= $data[invoice_id];
	    $url = 'https://bitpay.ir/payment/gateway-send';
        $result = send($url,$api,$amount,$redirect,$email,$description);

		if ($result > 0 && is_numeric($result))
		{
			$update[payment_rand]	= $result;
			$sql = $db->queryUpdate('payment', $update, 'WHERE `payment_rand` = "'.$order_id.'" LIMIT 1;');
			$db->execute($sql);
			$go = "https://bitpay.ir/payment/gateway-$result";
            header("Location: $go");
			exit;
		}
		else
		{
			//-- نمایش خطا
			$data[title] = 'خطای سیستم';
			$data[message] = '<font color="red">در ارتباط با درگاه bitpay مشکلی به وجود آمده است. لطفا مطمئن شوید کد API خود را به درستی در قسمت مدیریت وارد کرده اید.</font> شماره خطا: '.$result.'<br /><a href="index.php" class="button">بازگشت</a>';
			$smarty->assign('data', $data);
			$smarty->display('message.tpl');
			exit;

		}
	}

	function callback__bitpay($data)
	{
		global $db,$get,$smarty;
        $api = $data[pin];
        $url = 'https://bitpay.ir/payment/gateway-result-second';
        $trans_id = $_POST['trans_id'];
        $id_get = $_POST['id_get'];
        $result = get($url,$api,$trans_id,$id_get);

		if($result == 1)
		{
			$sql 		= 'SELECT * FROM `payment` WHERE `payment_rand` = "'.$id_get.'" LIMIT 1;';
			$payment 	= $db->fetch($sql);
			if ($payment)
			{
				if ($payment[payment_status] == 1)
				{
				    $output[status] = 1;
					$output[res_num] = NULL;
                    $output[ref_num] = $trans_id;
					$output[payment_id] = $payment[payment_id];

				}
				else
				{
					$output[status]	= 0;
					$output[message]= 'چنین سفارشی تعریف نشده است.';
				}
			}
			else
			{
				$output[status]	= 0;
				$output[message]= 'اطلاعات پرداخت کامل نیست.';
			}
		}
		else
		{
			$output[status]	= 0;
			$output[message]= 'پرداخت موفقيت آميز نبود';
		}
		return $output;
	}